/* -*- Mode: js2; tab-width: 4; indent-tabs-mode: nil; -*-
//@line 38 "/builddir/build/BUILD/spicebird-0.7.1/mozilla/collab/extensions/blog/content/BlogModule.js"
*/

/* components defined in this file */
const BLOG_ACCOUNT_MANGER_EXTENSION_CONTRACTID =
    "@mozilla.org/accountmanager/extension;1?name=blog";
const BLOG_ACCOUNT_MANGER_EXTENSION_CID =
    Components.ID("{71d536ec-3309-4b5c-9487-f6c3002e292e}");
const BLOG_MANAGER_CONTRACTID =
    "@synovel.com/blog/blog-manager;1";
const BLOG_MANAGER_CID =
    Components.ID("{0eb08a66-b640-40fb-ac72-a8d66fb8bae4}");

/* Some shortcuts */
const nsISupports                    = Components.interfaces.nsISupports;
const nsICategoryManager             = Components.interfaces.nsICategoryManager;
const nsIMsgAccountManagerExtension  = Components.interfaces.nsIMsgAccountManagerExtension;
const csIBlogManager                 = Components.interfaces.csIBlogManager;

/* Initialization code */
var gBlogModuleInitialized = false;

function loadScripts ()
{
  var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
    .getService(Components.interfaces.mozIJSSubScriptLoader);
  loader.loadSubScript("chrome://collab-blog/content/BlogAccountManagerExtension.js");
  loader.loadSubScript("chrome://collab-blog/content/BlogManager.js");
  loader.loadSubScript("chrome://collab-blog/content/performancing_api.js");
  loader.loadSubScript("chrome://collab-blog/content/xmlrpc.js");
  loader.loadSubScript("chrome://collab-blog/content/BlogUtils.js");
}

/* factory for BlogAccountManagerExtension */
var BlogAccountManagerExtensionFactory = new Object();

BlogAccountManagerExtensionFactory.createInstance =
function (outer, iid) {
  try
  {
    if (!gBlogModuleInitialized)
    {
      loadScripts();
      gBlogModuleInitialized = true;
    }
  }
  catch (ex)
  {
    throw Components.results.NS_ERROR_FAILURE;
  }

  if (outer != null)
    throw Components.results.NS_ERROR_NO_AGGREGATION;

  if (!iid.equals(nsIMsgAccountManagerExtension) && !iid.equals(nsISupports))
    throw Components.results.NS_ERROR_INVALID_ARG;

  return new BlogAccountManagerExtension();
};

/* factory for BlogManager */
var BlogManagerFactory = new Object();

BlogManagerFactory.createInstance = 
function (outer, iid) {
  try
  {
    if (!gBlogModuleInitialized)
    {
      loadScripts();
      gBlogModuleInitialized = true;
    }
  }
  catch (ex)
  {
    throw Components.results.NS_ERROR_FAILURE;
  }

  if (outer != null)
    throw Components.results.NS_ERROR_NO_AGGREGATION;

  if (!iid.equals(csIBlogManager) && !iid.equals(nsISupports))
    throw Components.results.NS_ERROR_INVALID_ARG;

  return new BlogManager();
};

var BlogModule = new Object();

BlogModule.registerSelf =
function (compMgr, fileSpec, location, type)
{
  compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
  compMgr.registerFactoryLocation(BLOG_ACCOUNT_MANGER_EXTENSION_CID,
                                  "Blog Account Manager Extension Service",
                                  BLOG_ACCOUNT_MANGER_EXTENSION_CONTRACTID, 
                                  fileSpec,
                                  location, 
                                  type);
  compMgr.registerFactoryLocation(BLOG_MANAGER_CID,
                                  "Blog Manager Service",
                                  BLOG_MANAGER_CONTRACTID, 
                                  fileSpec,
                                  location, 
                                  type);
  catman = Components.classes["@mozilla.org/categorymanager;1"].getService(nsICategoryManager);
  catman.addCategoryEntry("mailnews-accountmanager-extensions",
                          "blog account manager extension",
                          BLOG_ACCOUNT_MANGER_EXTENSION_CONTRACTID, true, true);
};

BlogModule.unregisterSelf =
function(compMgr, fileSpec, location)
{
  compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
  compMgr.unregisterFactoryLocation(BLOG_MANGER_CID, fileSpec);
  compMgr.unregisterFactoryLocation(BLOG_ACCOUNT_MANGER_EXTENSION_CID, fileSpec);
  catman = Components.classes["@mozilla.org/categorymanager;1"].getService(nsICategoryManager);
  catman.deleteCategoryEntry("mailnews-accountmanager-extensions",
                             BLOG_ACCOUNT_MANGER_EXTENSION_CONTRACTID, true);
};

BlogModule.getClassObject =
function (compMgr, cid, iid) {
  if (cid.equals(BLOG_ACCOUNT_MANGER_EXTENSION_CID))
    return BlogAccountManagerExtensionFactory;

  if (cid.equals(BLOG_MANAGER_CID))
    return BlogManagerFactory;

  if (!iid.equals(Components.interfaces.nsIFactory))
    throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

  throw Components.results.NS_ERROR_NO_INTERFACE;    
};

BlogModule.canUnload =
function(compMgr)
{
  return true;
};

/* entrypoint */
function NSGetModule(compMgr, fileSpec) {
  return BlogModule;
}
